<?php
/**
 * Load category and page alias.
 *
 * @access public
 * @return void
 */
public function loadAlias()
{
    if(isset($this->config->global->version))
    {
        /* The aliases won't be loaded if the global version <= 1.4. */
        $tmpVersion = $this->config->global->version;
        $this->config->global->version = '1.4.1';

        parent::loadAlias();

        $this->config->global->version = $tmpVersion;
    }
    else
    {
        parent::loadAlias();
    }
}

/**
 * Check the client can access the api or not.
 * 
 * @access public
 * @return void
 */
public function checkAPI()
{
    $key = ''; 
    if($this->post->key) $key = $this->post->key;
    if($this->get->key)  $key = $this->get->key;
    if($key != $this->config->apiKey) die('KEY ERROR!');
    //if(strpos($this->config->chanzhi->api->node->list, $this->server->remote_addr) === false) die('IP DENIED');
}

/**
 * Expend the method of isOpenMethod.
 * 
 * @param  string    $module 
 * @param  string    $method 
 * @access public
 * @return bool
 */
public function isOpenMethod($module, $method)
{
    if($module == 'portal' and $method == 'apideletesite')  return true;
    if($module == 'portal' and $method == 'apisavedomain')  return true;
    if($module == 'portal' and $method == 'apicheckdomain') return true;
    if($module == 'portal' and $method == 'apigettoken')    return true;
    if($module == 'portal' and $method == 'apigetsitecode') return true;
    if($module == 'node'   and $method == 'apigetconfig')   return true;

    return parent::isOpenMethod($module, $method);
}

/**
 * Print the plan param in the postionbar
 *
 * @param void
 * @access public
 * @return void
 */

public function printplan()
{
    echo '<li>' . $this->lang->plan->title . '</li>';
}

/**
 * Check cache need cache or not.
 * 
 * @static
 * @access public
 * @return bool
 */
public static function needClearCache()
{
    global $app, $config;

    /* The field stickTime of TABLE_ARTICLE was added in version 1.4. */
    if(version_compare($config->global->version, '1.4', '<')) return false;
    
    $overdueSticks = $app->loadClass('dao')->select('id')->from(TABLE_ARTICLE)->where('stickTime')->lt(helper::now())->andWhere('stickTime')->ne('0000-00-00 00:00:00')->fetchPairs();

    if(!empty($overdueSticks))
    {
        $app->loadClass('dao')->update(TABLE_ARTICLE)
            ->set('sticky')->eq('0')
            ->set('stickTime')->eq('0000-00-00 00:00:00')
            ->where('id')->in($overdueSticks)
            ->exec();

        return true;
    }
    return false;
}
