<?php
public function processRenewSiteOrder($order)
{
    $goods  = $this->dao->select('*')->from(TABLE_ORDER_PRODUCT)->where('orderID')->eq($order->id)->fetch();
    $result = $this->loadModel('portal')->processOrder($goods->productID);
    if($result == 'success')
    { 
        $status = new stdclass();
        $status->deliveryStatus = 'send';
        $status->status         = 'finished';
        $status->last           = helper::now();
        $this->dao->update(TABLE_ORDER)->data($status)->where('id')->eq($order->id)->exec();
        return !dao::isError();
    }
    return true;
}

public function processUpgradeOrder($order)
{
    return $this->processRenewSiteOrder($order);
}

public function printRenewsiteActions($order, $btnLink)
{
    if(RUN_MODE == 'admin')
    {
        $class = $btnLink ? 'btn' : '';

        /* Edit price link */
        $disabled = ($order->status == 'normal' and $order->payStatus !== 'paid') ? '' : "disabled='disabled'";
        echo $disabled ? html::a('javascript:;', $this->lang->order->editPrice, "$disabled class='$class'") : html::a(helper::createLink('order', 'editprice', "orderID=$order->id"), $this->lang->order->editPrice, "data-toggle='modal' class='$class'");
        
        /* Finish link. */
        $disabled = ($order->status == 'normal' and $order->payStatus == 'paid') ? '' : "disabled='disabled'";
        echo $disabled ? html::a('javascript:;', $this->lang->order->finish, "$disabled class='$class'") : html::a('javascript:;', $this->lang->order->finish, "data-rel='" . helper::createLink('order', 'finish', "orderID=$order->id") . "' class='finisher $class'");
    }
    
    if(RUN_MODE == 'front' and $order->status == 'normal')
    {
        /* Pay link. */
        $disabled = ($order->payment != 'COD' and $order->payStatus != 'paid') ? '' : "disabled='disabled'";
        echo $disabled ? html::a('#', $this->lang->order->pay, "class='' $disabled") : html::a(helper::createLink('order', 'check', "id=$order->id"), $this->lang->order->pay, "target='_blank' class='btn-go2pay warning'");
    }
}

public function printUpgradeActions($order, $btnLink)
{
    return $this->printRenewsiteActions($order, $btnLink);
}
