<?php
public function getStatData($date)
{
    return $this->dao->setAutoLang(false)->select('*')->from(TABLE_STAT)->where('date')->eq($date)->fetch();
}

public function getIPLine($labels)
{
    $traffic = $this->dao->setAutoLang(false)->select('date,pv,ip')->from(TABLE_STAT)
        ->where('date')->in($labels)
        ->fetchAll('date');

    foreach($labels as $time)
    {
        $pv[] = isset($traffic[$time]) ? $traffic[$time]->pv : 0;
        $ip[] = isset($traffic[$time]) ? $traffic[$time]->ip : 0;
    }

    $chartData = array();

    $pvChart = new stdclass();
    $pvChart->label = $this->lang->stat->pv;
    $pvChart->color = 'green';
    $pvChart->data  = $pv;

    $ipChart = new stdclass();
    $ipChart->label = $this->lang->stat->ipCount;
    $ipChart->color = 'red';
    $ipChart->data  = $ip;

    $chartData['pv'] = $pvChart;
    $chartData['ip'] = $ipChart;
    return $chartData;
}

public function getTrafficLine($labels)
{
    $portalTraffic = $this->dao->setAutoLang(false)->select('date,traffic')->from(TABLE_STAT)
        ->where('date')->in($labels)
        ->fetchAll('date');

    foreach($labels as $time)
    {
        $traffic[] = isset($portalTraffic[$time]) ? round($portalTraffic[$time]->traffic / (1024 * 1024), 2) : 0;
    }

    $chartData = array();

    $trafficChart = new stdclass();
    $trafficChart->label = $this->lang->stat->portalTraffic;
    $trafficChart->color = 'red';
    $trafficChart->data  = $traffic;

    $chartData['traffic'] = $trafficChart;
    return $chartData;
}

public function getDBLine($labels)
{
    $portalDB = $this->dao->setAutoLang(false)->select('date,db')->from(TABLE_STAT)
        ->where('date')->in($labels)
        ->fetchAll('date');

    foreach($labels as $time)
    {
        $db[] = isset($portalDB[$time]) ? round($portalDB[$time]->db / (1024 * 1024), 2) : 0;
    }

    $chartData = array();

    $dbChart = new stdclass();
    $dbChart->label = $this->lang->stat->portalDB;
    $dbChart->color = 'red';
    $dbChart->data  = $db;

    $chartData['db'] = $dbChart;
    return $chartData;
}

public function getFileLine($labels)
{
    $portalFile = $this->dao->setAutoLang(false)->select('date,file')->from(TABLE_STAT)
        ->where('date')->in($labels)
        ->fetchAll('date');

    foreach($labels as $time)
    {
        $file[] = isset($portalFile[$time]) ? round($portalFile[$time]->file / (1024 * 1024), 2) : 0;
    }

    $chartData = array();

    $fileChart = new stdclass();
    $fileChart->label = $this->lang->stat->portalFile;
    $fileChart->color = 'red';
    $fileChart->data  = $file;

    $chartData['file'] = $fileChart;
    return $chartData;
}

public function getNewSitesLine($labels)
{
    $portalSites = $this->dao->setAutoLang(false)->select('date,newSites')->from(TABLE_STAT)
        ->where('date')->in($labels)
        ->fetchAll('date');

    foreach($labels as $time)
    {
        $sites[] = isset($portalSites[$time]) ? $portalSites[$time]->newSites : 0;
    }

    $chartData = array();

    $siteChart = new stdclass();
    $siteChart->label = $this->lang->stat->newSites;
    $siteChart->color = 'red';
    $siteChart->data  = $sites;

    $chartData['site'] = $siteChart;
    return $chartData;
}

public function getTotalSitesLine($labels)
{
    $portalSites = $this->dao->setAutoLang(false)->select('date,totalSites')->from(TABLE_STAT)
        ->where('date')->in($labels)
        ->fetchAll('date');

    foreach($labels as $time)
    {
        $sites[] = isset($portalSites[$time]) ? $portalSites[$time]->totalSites : 0;
    }

    $chartData = array();

    $siteChart = new stdclass();
    $siteChart->label = $this->lang->stat->totalSites;
    $siteChart->color = 'red';
    $siteChart->data  = $sites;

    $chartData['site'] = $siteChart;
    return $chartData;
}

public function getNewUsersLine($labels)
{
    $portalSites = $this->dao->setAutoLang(false)->select('date,newUsers')->from(TABLE_STAT)
        ->where('date')->in($labels)
        ->fetchAll('date');

    foreach($labels as $time)
    {
        $users[] = isset($portalSites[$time]) ? $portalSites[$time]->newUsers : 0;
    }

    $chartData = array();

    $userChart = new stdclass();
    $userChart->label = $this->lang->stat->totalSites;
    $userChart->color = 'red';
    $userChart->data  = $users;

    $chartData['user'] = $userChart;
    return $chartData;
}
